#!/bin/awk -f
#
#
# Copyright 2005 DN Systems GmbH
#
#

BEGIN { FS = ":"; }
/^p/ { plugin = $2; plugins[plugin] = $3; count[plugin] = 0; }
/^s/ { set = $4; sets[plugin, count[plugin]] = $4; setdescs[plugin, count[plugin]] = $5; 
 count[plugin]++; count[plugin, set] = 0; }
/^e/ { entries[plugin, set, count[plugin, set]] = $5; 
 entrydescs[plugin, set, count[plugin, set]] = plugins[plugin] " " $6;
 count[plugin, set]++; } 

END {
  printf ("#\n#\n# Copyright (C)2005 DN-Systems GmbH\n#\n#\n\n");
  printf ("# Dynamically generated plugin configuration\n");
  printf ("function init_add_preferences () {\n");
  for (plugin in plugins) {
    printf ("  script_add_preference (name: \"%s\", type: \"checkbox\", value: \"yes\");\n",
	    plugins[plugin]);
    options = "";
    if (count[plugin] > 1) {
      for (i=0; i<count[plugin]; i++) 
	if (i == 0) options = setdescs[plugin, 0];
	else options = options ";" setdescs[plugin, i];
      printf ("  script_add_preference (name: \"%s level\", type: \"radio\", value: \"%s\");\n",
	      plugin, options);
    }
  }
  printf ("}\n");
  printf ("# End of dynamically generated plugin configuration\n");
  printf ("\n");


  printf ("# Dynamically generated plugin running\n");
  printf ("function run_slad (sock, slad_exe) {\n");
  for (plugin in plugins) {
    printf ("  # %s\n", plugin);
    printf ("  run = script_get_preference (\"%s\");\n",
	    plugins[plugin]);
    if (count[plugin] > 1) {
      printf ("  level = script_get_preference (\"%s level\");\n", plugin);
      for (i=0; i<count[plugin]; i++)
	if (i == 0) printf ("  if (level == \"%s\") slad_cmd = slad_exe + \"-r %s:%s\";\n",
			    setdescs[plugin, 0], plugin, sets[plugin, 0]);
	else printf ("  else if (level == \"%s\") slad_cmd = slad_exe + \"-r %s:%s\";\n",
		     setdescs[plugin, i], plugin, sets[plugin, i]);
    } else {
      printf ( "  slad_cmd = slad_exe + \" -r %s:%s\";\n",
	       plugin, sets[plugin, 0]);
    }
    printf ("  if (run == \"yes\") results += ssh_cmd (socket: sock, cmd: slad_cmd, timeout: 60);\n");
  }
  printf ("  if (results) security_warning (port: 22, data: results);\n");
  printf ("}\n");
  printf ("# End of dynamically generated plugin running\n");
  printf ("\n");


  printf ("# Dynamically generated plugin descriptions\n");
  printf ("function get_slad_description (entry) {\n");
  ecount = 0;
  for (plugin in plugins)
    for (i=0; i<count[plugin]; i++) {
      set = sets[plugin, i];
      for (j=0; j<count[plugin, set]; j++) {
	entry = entries[plugin, set, j];
	if (ecount > 0) printf ("  else ");
	else printf ("  ");
	printf ("if (entry == \"%s:%s:%s\") return \"%s\";\n", plugin, set, entry, entrydescs[plugin, set, j]);
	ecount++;
      }
    }
  printf ("}\n");
  printf ("# End of dynamically generated plugin descriptions\n");
  printf ("\n");


  printf ("# Dynamically generated debug dump\n");
  printf ("function dump_preferences () {\n");
  for (plugin in plugins) {
    printf ("  display (\"%s: \", script_get_preference (\"%s\"), \"\\n\");\n", plugin, plugins[plugin]);
    if (count[plugin] > 1)
      printf ("  display (\"  level: \", script_get_preference (\"%s level\"), \"\\n\");\n", plugin);
  }
  printf ("}\n");
  printf ("# End of dynamically generated debug dump\n");
}
