#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "struct.h"

void show_plugins (int socket, sladd_config_t * config) {
  slad_plugin_t * plugin;
  slad_plugin_set_t * set;
  slad_plugin_entry_t * entry;
  int p_num = 0, s_num = 0, e_num = 0;
  char buffer [1024];

  if (config->plugins)
    for (p_num = 0; (plugin = config->plugins[p_num]); p_num++) {
      snprintf (buffer, 1024, "p:%s:%s\n", plugin->name, plugin->desc);
      write (socket, buffer, strlen (buffer));
      if (plugin->sets)
	for (s_num = 0; (set = plugin->sets[s_num]); s_num++) {
	  snprintf (buffer, 1024, "s:%d:%s:%s:%s\n",
		    set->is_default ? 1 : 0,
		    plugin->name, set->name,
		    set->desc ? set->desc :
		    plugin->desc);
	  write (socket, buffer, strlen (buffer));
	  if (set->entries)
	    for (e_num = 0; (entry = set->entries[e_num]); e_num++) {
	      snprintf (buffer, 1024, "e:%d:%s:%s:%s:%s\n",
			entry->is_default ? 1 : 0,
			plugin->name, set->name, entry->name,
			entry->desc ? entry->desc:
			set->desc ? set->desc:
		      plugin->desc);
	      write (socket, buffer, strlen (buffer));
	    }
	}
    }
}
